/* 
*
*  ProLinga-Calc
*
*  Copyright (C) 2002-2009 Xobas Software
*  All rights reserved.
*  
*  This file is part of ProLinga-Calc.
*
*  ProLinga-Calc is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  ProLinga-Calc is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with ProLinga-Calc. If not, see <http://www.gnu.org/licenses/>.
*
*  More information is available at the following addresses:
*
*  Website     : http://www.prolinga.org
*
*  Email       : prolinga-list@prolinga.org
*
*/

#include "CalcCommon.h"
#include "CalcMain.hpp"
#include <prolinga/Calc.hpp>

void Usage(const char *progName)
{
	printf("Usage : %s [ [--version] || [\"expression\"] ] \n", progName);
	printf("        %s  \n", progName);
}

int main(int argc, char* argv[])
{ 
	char *result;
	PlCalc calc;
	int i;

	if (argc > 1)
	{
		for (i=1;i<argc;i++)
		{ 

			if ((!strcmp(argv[i], "-version")) || (!strcmp(argv[i], "--version")))
			{
				fprintf(stderr,"%s version: %s\n", argv[0], VERSION);
				fprintf(stderr,"Copyright © 2002-2009 The ProLinga Team.\n");
				fprintf(stderr,"All rights reserved.\n");
				return 0;
			}
			else if ( (!strcmp(argv[i], "-help")) || (!strcmp(argv[i], "--help")) || (!strcmp(argv[i], "?")) || (!strcmp(argv[i], "-?")) )
			{
				Usage(argv[0]);
				return 0;
			}
			else
			{
				result = calc.getCalc(argv[i]);
				printf("%s\n", result);
				return 0;
			}
		}
	}
	else
	{ 
		char buf[CALC_MAX_EXP_LEN];
		printf("\nprolingacalc %s\nC expression command line calculator.\nType \"help\" for more information.\n(c) 2002-2009 The ProLinga Team.\n\n", VERSION);
		printf(CALC_PROMPT);
		while (fgets(buf, sizeof buf, stdin) != NULL)
		{ 
			if (strncmp(buf, "help", 4) == 0 || strncmp(buf, "HELP", 4) == 0 || buf[0] == '?')
	    		{
				printf(CALC_HELP);
			}
			else if (strncmp(buf, "version", 7) == 0 || strncmp(buf, "VERSION", 7) == 0 || buf[0] == '?')
	    		{
				printf("%s version: %s\n", argv[0], VERSION);
				printf("Copyright © 2002-2009 The ProLinga Team.\n");
                        	printf("All rights reserved.\n");

			}
			else if (strncmp(buf,"exit",4)==0 || strncmp(buf,"EXIT",4)==0 || strncmp(buf,"quit",4)==0 || strncmp(buf,"QUIT",4)==0)
			{
				return 0;
			}
			else
			{ 	
				result = calc.getCalc(buf);
				printf("Result : %s\n", result);
	    		}
			printf(CALC_PROMPT);
		}
	}
	return 0;
}


